
/**************/
/* 15. XML  */
/**************/


/* -------------------------------
       <ǽ1> p677 ~ p679
---------------------------------*/

USE master ;
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE ;

USE sqlDB;
CREATE TABLE xmlTbl (id INT PRIMARY KEY, xmlCol XML);

INSERT INTO xmlTbl VALUES(N'Ϲ ؽƮ Է');

INSERT INTO xmlTbl VALUES(N'<html> <body> <b> Ϲ ؽƮ Է</b> </body> </html>' );

INSERT INTO xmlTbl VALUES(N'<html> <body> <b> ϹؽƮԷ</body> </html>' );

INSERT INTO xmlTbl VALUES(N'<?xml version="1.0" ?>
<document>
<userTbl name="ȯ" birthYear="1979" addr=" " />
<userTbl name="ö" birthYear="1975" addr=" " />
<userTbl name="" birthYear="1986" addr=" " />
<userTbl name="賲" birthYear="1977" addr=" " />
</document>
');

INSERT INTO xmlTbl VALUES(N'
<userTbl name="ȯ" birthYear="1979" addr=" " />
<userTbl name="ö" birthYear="1975" addr=" " />
');

DECLARE @x  XML
SET @x = N'<userTbl name="ȯ" birthYear="1979" addr=" " />'
PRINT CAST(@x AS NVARCHAR(MAX))


/* -------------------------------
       <ǽ2> p679 ~ p683
---------------------------------*/

SELECT * FROM userTbl FOR XML RAW, ELEMENTS, XMLSCHEMA

CREATE XML SCHEMA COLLECTION schema_userTbl AS '
<xsd:schema targetNamespace="urn:schemas-microsoft-com:sql:SqlRowSet1" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:sqltypes="http://schemas.microsoft.com/sqlserver/2004/sqltypes" elementFormDefault="qualified">
  <xsd:import namespace="http://schemas.microsoft.com/sqlserver/2004/sqltypes" schemaLocation="http://schemas.microsoft.com/sqlserver/2004/sqltypes/sqltypes.xsd" />
  <xsd:element name="row">
    <xsd:complexType>
      <xsd:sequence>
        <xsd:element name="userID">
          <xsd:simpleType>
            <xsd:restriction base="sqltypes:nchar" sqltypes:localeId="1042" sqltypes:sqlCompareOptions="IgnoreCase IgnoreKanaType IgnoreWidth">
              <xsd:maxLength value="8" />
            </xsd:restriction>
          </xsd:simpleType>
        </xsd:element>
        <xsd:element name="name">
          <xsd:simpleType>
            <xsd:restriction base="sqltypes:nvarchar" sqltypes:localeId="1042" sqltypes:sqlCompareOptions="IgnoreCase IgnoreKanaType IgnoreWidth">
              <xsd:maxLength value="10" />
            </xsd:restriction>
          </xsd:simpleType>
        </xsd:element>
        <xsd:element name="birthYear" type="sqltypes:int" />
        <xsd:element name="addr">
          <xsd:simpleType>
            <xsd:restriction base="sqltypes:nchar" sqltypes:localeId="1042" sqltypes:sqlCompareOptions="IgnoreCase IgnoreKanaType IgnoreWidth">
              <xsd:maxLength value="4" />
            </xsd:restriction>
          </xsd:simpleType>
        </xsd:element>
        <xsd:element name="mobile1" minOccurs="0">
          <xsd:simpleType>
            <xsd:restriction base="sqltypes:nchar" sqltypes:localeId="1042" sqltypes:sqlCompareOptions="IgnoreCase IgnoreKanaType IgnoreWidth">
              <xsd:maxLength value="3" />
            </xsd:restriction>
          </xsd:simpleType>
        </xsd:element>
        <xsd:element name="mobile2" minOccurs="0">
          <xsd:simpleType>
            <xsd:restriction base="sqltypes:nchar" sqltypes:localeId="1042" sqltypes:sqlCompareOptions="IgnoreCase IgnoreKanaType IgnoreWidth">
              <xsd:maxLength value="8" />
            </xsd:restriction>
          </xsd:simpleType>
        </xsd:element>
        <xsd:element name="height" type="sqltypes:smallint" minOccurs="0" />
      </xsd:sequence>
    </xsd:complexType>
  </xsd:element>
</xsd:schema>
'

USE sqlDB;
CREATE TABLE tXmlTbl (id INT IDENTITY, xmlCol XML (schema_userTbl) );

INSERT INTO tXmlTbl VALUES(N'Ϲ ؽƮ Է');

INSERT INTO tXmlTbl VALUES(N'
<row xmlns="urn:schemas-microsoft-com:sql:SqlRowSet2">
  <userID>AJH     </userID>
  <name>ȯ</name>
  <birthYear>1979</birthYear>
  <addr> </addr>
  <height>182</height>
</row>
');

INSERT INTO tXmlTbl VALUES(N'
<row xmlns="urn:schemas-microsoft-com:sql:SqlRowSet2">
  <name></name>
  <userID>PJS     </userID>
  <birthYear>1983</birthYear>
  <addr> </addr>
  <mobile1>011</mobile1>
  <mobile2>1111111 </mobile2>
  <height>181</height>
</row>
');

DECLARE @tx XML(schema_userTbl)
SET @tx = N'
<row xmlns="urn:schemas-microsoft-com:sql:SqlRowSet2">
  <userID>CJC     </userID>
  <name>ö</name>
  <birthYear>1975</birthYear>
  <addr> </addr>
  <mobile1>019</mobile1>
  <mobile2>0000000 </mobile2>
  <height>185</height>
</row>'
INSERT INTO  tXmlTbl VALUES(@tx)

SELECT * FROM sys.xml_schema_collections;

SELECT XML_SCHEMA_NAMESPACE(N'dbo', N'schema_userTbl');

DROP XML SCHEMA COLLECTION schema_userTbl


/* -------------------------------
       <ǽ3> p684 ~ p686
---------------------------------*/

USE sqldb;
SELECT Title, FirstName, MiddleName, LastName, EmailAddress, Phone
	 FROM  AdventureWorks.Person.Contact
	WHERE contactid = 1
        FOR XML RAW

CREATE TABLE indexXmlTbl (id INT IDENTITY NOT NULL PRIMARY KEY, 
	fullName VARCHAR(30), xmlInfo XML);

DECLARE @xml XML -- XML 
DECLARE @fullName VARCHAR(20)
DECLARE @contactId INT -- ContactID 
DECLARE @i INT -- ݺ 
DECLARE @cnt INT -- ü  
SET @i = 1;
SET @contactId = 1; 
SELECT @cnt = COUNT(contactID) FROM AdventureWorks.Person.Contact; --   
WHILE (@i <= @cnt) -- ൥  ŭ
BEGIN
	SET @fullName = (SELECT FirstName + ' ' + LastName 
				FROM  AdventureWorks.Person.Contact
				WHERE contactID = @contactId )
	IF (@fullName <> '') -- ش contactId ڰ ִٸ..
	BEGIN
		SET @xml = (SELECT Title, FirstName, MiddleName, LastName, EmailAddress, Phone
					FROM  AdventureWorks.Person.Contact
					WHERE contactID = @contactId
					FOR XML RAW )
		INSERT INTO indexXmlTbl VALUES (@fullName, @xml);
		SET @i = @i + 1
	END
	SET @contactId = @contactId + 1
END

SELECT * FROM indexXmlTbl;

SELECT * INTO noIndexXmlTbl FROM indexXmlTbl;

CREATE PRIMARY XML INDEX xmlIdx_indexXmlTbl_xmlInfo
	ON indexXmlTbl (xmlInfo);

SELECT * FROM indexXmlTbl
	WHERE xmlInfo.exist('/row[@Phone="334-555-0137"]') = 1;

SELECT * FROM noIndexXmlTbl
	WHERE xmlInfo.exist('/row[@Phone="334-555-0137"]') = 1;


/* -------------------------------
       <ǽ4> p687 ~ p691
---------------------------------*/

USE sqlDB;
SELECT userId,name,addr,height FROM userTbl 
	WHERE height > 180
	FOR XML RAW;

SELECT userId,name,addr,height FROM userTbl 
	WHERE height > 180
	FOR XML RAW ('ȸ');

SELECT userId,name,addr,height FROM userTbl 
	WHERE height > 180
	FOR XML RAW ('ȸ') , ROOT;

SELECT userId,name,addr,height FROM userTbl 
	WHERE height > 180
	FOR XML RAW , ELEMENTS;

SELECT userId,name,addr,height FROM userTbl 
	WHERE height > 180
	FOR XML RAW , XMLDATA;

SELECT userId,name,addr,height FROM userTbl 
	WHERE height > 180
	FOR XML RAW , XMLSCHEMA;

SELECT userId,name,addr,height FROM userTbl 
	WHERE height > 180
	FOR XML AUTO;

SELECT userId,name,addr,mobile1, mobile2 FROM userTbl 
	WHERE height > 180
	FOR XML AUTO, ELEMENTS;

SELECT userId,name,addr,mobile1, mobile2 FROM userTbl 
	WHERE height > 180
	FOR XML AUTO, ELEMENTS XSINIL;


/* -------------------------------
       <ǽ5> p692 ~ p693
---------------------------------*/

DECLARE @handle INT -- ڵ
DECLARE @xmlDoc XML -- XML 
SET @xmlDoc = (SELECT userId,name,addr FROM userTbl 
	WHERE height > 180
	FOR XML AUTO , ROOT); -- xml  · ȯ
EXEC sp_xml_preparedocument @handle OUTPUT, @xmlDoc; -- XML  м
SELECT * FROM OPENXML(@handle, '/root/userTbl',0)
	WITH (userId nchar(8),
		  name nvarchar(10),
		  addr nchar(4) ); -- ǥ ·  ó
EXEC sp_xml_removedocument @handle; -- ޸ 


