
/********************************************/
/* 6. ʼ ˾ƾ  Transact-SQL     */
/********************************************/

-----------------
-- P171 ~ P174
-----------------

USE AdventureWorks

SELECT * FROM HumanResources.Employee

SELECT * FROM BRAIN.AdventureWorks.HumanResources.Employee

SELECT * FROM Employee

SELECT * FROM BRAIN.AdventureWorks.dbo.Employee

SELECT Name FROM HumanResources.Department

SELECT Name, GroupName FROM HumanResources.Department

-- ⼭  (P174)
--  ּ 
SELECT Name, GroupName  -- ̸ ׷̸  
FROM HumanResources.Department

/*  ּ 
SELECT Name, GroupName  
FROM HumanResources.Department
*/


/* -------------------------------
       <ǽ1> p175 ~ p176
---------------------------------*/

EXEC sp_helpdb;

USE AdventureWorks

EXEC sp_tables  @table_type = "'TABLE'" ;

EXEC sp_columns 
   @table_name = 'Department',
   @table_owner = 'HumanResources';

SELECT Name, GroupName FROM HumanResources.Department 

-- ⼭  (P176)
SELECT DepartmentID AS μȣ, Name 'μ̸', [׷̸] = GroupName
FROM HumanResources.Department


/* -------------------------------
       <ǽ2> p178 ~ p181
---------------------------------*/

USE master
CREATE DATABASE sqlDB
GO

USE sqlDB
CREATE TABLE userTbl -- ̺
( userID  nchar(8) NOT NULL PRIMARY KEY, -- ھ̵
  name    nvarchar(10) NOT NULL, -- ̸
  birthYear   int NOT NULL,  -- ⵵
  addr	  nchar(4) NOT NULL, -- (,,泲,Ͻ2ڸԷ)
  mobile1	nchar(3), -- ޴Ǳ(011, 016, 017, 018, 019, 010 )
  mobile2   nchar(8), -- ޴ǳȭȣ()
height    smallint  -- 
)
GO
CREATE TABLE buyTbl -- ڱ̺
(  num int IDENTITY NOT NULL PRIMARY KEY, -- (PK)
   userid  nchar(8) NOT NULL --̵(FK)
		FOREIGN KEY REFERENCES userTbl(userid),
   prodName nchar(6) NOT NULL, -- ǰ
   groupName nchar(4)  , -- з
   price     int  NOT NULL, -- ܰ
   amount    smallint  NOT NULL -- 
)
GO

INSERT INTO userTbl VALUES(N'PJS', N'', 1983, N'', N'011', N'1111111', 181)
INSERT INTO userTbl VALUES(N'PJY', N'ֿ', 1986, N'', N'011', N'2222222', 178)
INSERT INTO userTbl VALUES(N'JJJ', N'', 1986, N'', N'019', N'3333333', 179)
INSERT INTO userTbl VALUES(N'LCS', N'õ', 1983, N'õ', N'011', N'4444444', 179)
INSERT INTO userTbl VALUES(N'AJH', N'ȯ', 1979, N'', NULL  , NULL      , 182)
INSERT INTO userTbl VALUES(N'KNI', N'賲', 1977, N'', N'016', N'6666666', 183)
INSERT INTO userTbl VALUES(N'LYP', N'̿ǥ', 1983, N'', NULL  , NULL      , 178)
INSERT INTO userTbl VALUES(N'SKH', N'', 1978, N'', N'011', N'8888888', 182)
INSERT INTO userTbl VALUES(N'SJK', N'', 1979, N'', N'018', N'9999999', 178)
INSERT INTO userTbl VALUES(N'CJC', N'ö', 1975, N'', N'019', N'0000000', 185)
GO
INSERT INTO buyTbl VALUES(N'PJY', N'ȭ', NULL   , 30,   2)
INSERT INTO buyTbl VALUES(N'PJY', N'Ʈ', N'', 1000, 1)
INSERT INTO buyTbl VALUES(N'LCS', N'', N'', 200,  1)
INSERT INTO buyTbl VALUES(N'CJC', N'', N'', 200,  5)
INSERT INTO buyTbl VALUES(N'PJY', N'û', N'Ƿ', 50,   3)
INSERT INTO buyTbl VALUES(N'CJC', N'޸', N'', 80,  10)
INSERT INTO buyTbl VALUES(N'AJH', N'å'    , N'', 15,   5)
INSERT INTO buyTbl VALUES(N'SKH', N'å'    , N'', 15,   2)
INSERT INTO buyTbl VALUES(N'SKH', N'û', N'Ƿ', 50,   1)
INSERT INTO buyTbl VALUES(N'CJC', N'ȭ', NULL   , 30,   2)
INSERT INTO buyTbl VALUES(N'SKH', N'å'    , N'', 15,   1)
INSERT INTO buyTbl VALUES(N'CJC', N'ȭ', NULL   , 30,   2)
GO

SELECT * FROM userTbl
SELECT * FROM buyTbl

USE master
BACKUP DATABASE sqlDB TO DISK = 'C:\sqlDB.bak'


-------------------------------
-- P181 ~ P192
-------------------------------

SELECT * FROM userTbl

SELECT * FROM userTbl WHERE name = ''

SELECT userID, Name FROM userTbl WHERE birthYear >= 1981 AND height >= 180

SELECT userID, Name FROM userTbl WHERE birthYear >= 1981 OR height >= 180

SELECT Name, height FROM userTbl WHERE height >= 180 AND height <= 183

SELECT Name, height FROM userTbl WHERE height BETWEEN 180 AND 183

SELECT Name, height FROM userTbl WHERE height=178 OR height=180 OR height=182

SELECT Name, height FROM userTbl WHERE height IN (178, 180, 182)

SELECT Name, height FROM userTBL WHERE height > 181

SELECT Name, height FROM userTbl 
  WHERE height > (SELECT height FROM userTbl WHERE Name = '')

SELECT Name, height FROM userTbl 
  WHERE height >= (SELECT height FROM userTbl WHERE mobile1 = '019')

SELECT Name, height FROM userTbl 
  WHERE height >= ANY (SELECT height FROM userTbl WHERE mobile1 = '019')

SELECT Name, height FROM userTbl 
  WHERE height = ANY (SELECT height FROM userTbl WHERE mobile1 = '019')

SELECT Name, height FROM userTbl 
  WHERE height IN (SELECT height FROM userTbl WHERE mobile1 = '019')

SELECT Name, height FROM userTbl ORDER BY height

SELECT Name, height FROM userTbl ORDER BY height DESC

SELECT Name, height FROM userTbl ORDER BY height DESC, name ASC

SELECT addr FROM userTbl

SELECT addr FROM userTbl ORDER BY addr

SELECT DISTINCT addr FROM userTbl

USE AdventureWorks
SELECT CreditCardID FROM Sales.CreditCard 
WHERE CardType = 'Vista'
ORDER BY ExpYear, ExpMonth

SELECT TOP(10) CreditCardID FROM Sales.CreditCard 
WHERE CardType = 'Vista'
ORDER BY ExpYear, ExpMonth

SELECT TOP(SELECT COUNT(*)/100 FROM Sales.CreditCard ) CreditCardID 
FROM Sales.CreditCard 
WHERE CardType = 'Vista'
ORDER BY ExpYear, ExpMonth

SELECT TOP(0.1)PERCENT CreditCardID FROM Sales.CreditCard 
WHERE CardType = 'Vista'
ORDER BY ExpYear, ExpMonth

SELECT TOP(0.1)PERCENT WITH TIES CreditCardID, ExpMonth, ExpYear FROM Sales.CreditCard 
WHERE CardType = 'Vista'
ORDER BY ExpYear, ExpMonth

USE AdventureWorks
SELECT * FROM  Sales.SalesOrderDetail TABLESAMPLE(5 PERCENT)

SELECT TOP(5000) * FROM  Sales.SalesOrderDetail TABLESAMPLE(5 PERCENT)

USE sqlDB
SELECT * INTO buyTbl2 FROM buyTbl
SELECT * FROM buyTbl2

SELECT userid, prodName INTO buyTbl3 FROM buyTbl
SELECT * FROM buyTbl3


-------------------------------
-- P193 ~ P198
-------------------------------

USE sqlDB
SELECT userid, price, amount FROM buyTbl ORDER BY userid

SELECT userid, SUM(amount)  FROM buyTbl GROUP BY userid

SELECT userid AS [ھ̵], SUM(amount) AS [ѱŰ]  
  FROM buyTbl GROUP BY userid

SELECT userid AS [ھ̵], SUM(price*amount) AS [ѱž]  
  FROM buyTbl GROUP BY userid

SELECT AVG(amount) AS [ձŰ] FROM buyTbl

SELECT AVG(amount*1.0) AS [ձŰ] FROM buyTbl
  -- Ǵ
SELECT AVG(CAST(amount AS DECIMAL(10,6))) AS [ձŰ] FROM buyTbl

SELECT userid, AVG(amount*1.0) AS [ձŰ] FROM buyTbl
  GROUP BY userid

SELECT Name, MAX(height), MIN(height) FROM userTbl

SELECT Name, MAX(height), MIN(height) FROM userTbl GROUP BY Name

SELECT Name, height
FROM userTbl 
WHERE height = (SELECT MAX(height)FROM userTbl) 
   OR height = (SELECT MIN(height)FROM userTbl)

SELECT COUNT(*) FROM userTbl

SELECT COUNT(mobile1) FROM userTbl


/* -------------------------------
       <ǽ3> p198 ~ p201
---------------------------------*/

USE AdventureWorks
GO
SELECT * FROM Sales.Customer
GO
SELECT COUNT(*) FROM Sales.Customer
GO

USE sqlDB
SELECT num, price, amount INTO #tmpTbl FROM buyTbl
GO
INSERT INTO #tmpTbl
   SELECT a.price, a.amount FROM #tmpTbl a, #tmpTbl b
GO

SELECT sum(price*amount) from #tmpTbl

DECLARE @total bigint -- @total ѱž ų
DECLARE @priceXamount int -- @priceXamount  ݰ  Ѱ  
DECLARE @num int -- @num ̺  
DECLARE @count int -- @count ü 
SET @total=0
SET @num=1
SELECT @count=COUNT(*) FROM #tmpTbl
SET @count = @count + 1
WHILE @count <> @num
BEGIN
	SELECT @priceXamount = price * amount FROM  #tmpTbl
		WHERE num = @num
    SET @num = @num + 1
    SET @total = @total + @priceXamount
END
PRINT @total


-------------------------------
-- P201 ~ P208
-------------------------------

SELECT userid AS [], SUM(price*amount) AS [ѱž]  
  FROM buyTbl 
  GROUP BY userid

SELECT userid AS [], SUM(price*amount) AS [ѱž]  
  FROM buyTbl 
  WHERE SUM(price*amount) > 1000 
  GROUP BY userid

SELECT userid AS [], SUM(price*amount) AS [ѱž]  
  FROM buyTbl 
  GROUP BY userid
  HAVING SUM(price*amount) > 1000

SELECT userid AS [], SUM(price*amount) AS [ѱž]  
  FROM buyTbl 
  GROUP BY userid
  HAVING SUM(price*amount) > 1000 
  ORDER BY SUM(price*amount)  ASC

SELECT *, price*amount AS [] FROM buyTbl
  COMPUTE SUM(price * amount)
  COMPUTE AVG(price * amount)

SELECT *, price * amount FROM buyTbl
ORDER BY groupName
  COMPUTE SUM(price * amount) BY groupName
  COMPUTE AVG(price * amount) BY groupName

SELECT *, price * amount FROM buyTbl
ORDER BY groupName
  COMPUTE SUM(price * amount) BY groupName
  COMPUTE AVG(price * amount) BY groupName
  COMPUTE SUM(price * amount)
  COMPUTE AVG(price * amount)

SELECT num,  groupName, SUM(price * amount) AS [] 
FROM buyTbl
GROUP BY groupName, num
   WITH ROLLUP

SELECT groupName, SUM(price * amount) AS [] 
FROM buyTbl
GROUP BY groupName
   WITH ROLLUP

SELECT groupName, SUM(price * amount) AS [] 
        , GROUPING(groupName) AS [߰࿩]
FROM buyTbl
GROUP BY groupName
   WITH ROLLUP

USE sqlDB
CREATE TABLE cubeTbl(prodName NCHAR(3), color NCHAR(2), amount INT)
GO
INSERT INTO cubeTbl VALUES('ǻ', '', 11)
INSERT INTO cubeTbl VALUES('ǻ', 'Ķ', 22)
INSERT INTO cubeTbl VALUES('', '', 33)
INSERT INTO cubeTbl VALUES('', 'Ķ', 44)
GO
SELECT prodName, color, SUM(amount) AS [հ]
FROM cubeTbl
GROUP BY prodName, color 
   WITH CUBE


-------------------------------
-- P210 ~ P213
-------------------------------

SELECT userid AS [], SUM(price*amount) AS [ѱž]  
  FROM buyTbl GROUP BY userid

USE sqlDB

WITH abc(userid, total)
AS
(SELECT userid, SUM(price*amount)  
  FROM buyTbl GROUP BY userid )
SELECT * FROM abc ORDER BY total DESC ;

SELECT addr, MAX(height) FROM userTbl GROUP BY addr

WITH cte_userTbl(addr, maxHeight)
AS
  ( SELECT addr, MAX(height) FROM userTbl GROUP BY addr)

WITH cte_userTbl(addr, maxHeight)
AS
  ( SELECT addr, MAX(height) FROM userTbl GROUP BY addr)
SELECT AVG(maxHeight*1.0) AS [ְŰ] FROM cte_userTbl

SELECT * FROM userTbl
WITH abc(userid, total)
AS
(SELECT userid, SUM(price*amount)  
  FROM buyTbl GROUP BY userid )
SELECT * FROM abc ORDER BY total DESC

SELECT * FROM userTbl
GO
WITH abc(userid, total)
AS
(SELECT userid, SUM(price*amount)  
  FROM buyTbl GROUP BY userid )
SELECT * FROM abc ORDER BY total DESC
  -- Ǵ
SELECT * FROM userTbl ;
WITH abc(userid, total)
AS
(SELECT userid, SUM(price*amount)  
  FROM buyTbl GROUP BY userid )
SELECT * FROM abc ORDER BY total DESC


/* -------------------------------
       <ǽ4> p215 ~ p218
---------------------------------*/

USE sqlDB
CREATE TABLE empTbl (emp NCHAR(3), manager NCHAR(3), department NCHAR(3))
GO

INSERT INTO empTbl VALUES('',NULL,NULL)
INSERT INTO empTbl VALUES('繫','','繫')
INSERT INTO empTbl VALUES('','繫','繫')
INSERT INTO empTbl VALUES('̺','繫','繫')
INSERT INTO empTbl VALUES('븮','̺','繫')
INSERT INTO empTbl VALUES('','̺','繫')
INSERT INTO empTbl VALUES('̿','','')
INSERT INTO empTbl VALUES('Ѱ','̿','')
INSERT INTO empTbl VALUES('','','')
INSERT INTO empTbl VALUES('','','')
INSERT INTO empTbl VALUES('','','')

WITH empCTE(empName, mgrName, dept, level)
AS
(
  SELECT emp, manager, department , 0  
       FROM empTbl 
       WHERE manager IS NULL --    ٷ  
  UNION ALL
  SELECT AA.emp, AA.manager, AA.department, BB.level+1
   FROM empTbl AS AA INNER JOIN empCTE AS BB
        ON AA.manager = BB.empName
)
SELECT  FROM empCTE ORDER BY dept, level

WITH empCTE(empName, mgrName, dept, level)
AS
(
  SELECT emp, manager, department , 0  
       FROM empTbl 
       WHERE manager IS NULL --  
  UNION ALL
  SELECT AA.emp, AA.manager, AA.department, BB.level+1
   FROM empTbl AS AA INNER JOIN empCTE AS BB
        ON AA.manager = BB.empName
)
SELECT replicate(' ', level) + empName AS [̸], dept [μ]
   FROM empCTE  ORDER BY dept, level

WITH empCTE(empName, mgrName, dept, level)
AS
(
  SELECT emp, manager, department , 0  
       FROM empTbl 
       WHERE manager IS NULL --  
  UNION ALL
  SELECT AA.emp, AA.manager, AA.department, BB.level+1
   FROM empTbl AS AA INNER JOIN empCTE AS BB
        ON AA.manager = BB.empName
   WHERE level < 2
)
SELECT replicate(' ', level) + empName AS [̸], dept [μ]
   FROM empCTE  ORDER BY dept, level


-------------------------------
-- P220 ~ P225
-------------------------------

USE tempDB
CREATE TABLE testTbl1 (id  int, userName nchar(3), age int);
GO
INSERT INTO testTbl1 VALUES (1, '񵿱', 25)

INSERT INTO testTbl1(id, userName) VALUES (2, 'Ƶ庹')

INSERT INTO testTbl1(userName, age, id) VALUES ('ȫ', 31,  3)

CREATE TABLE testTbl2 
 (id  int IDENTITY, userName nchar(3), 
    age int, nation nchar(4) DEFAULT 'ѹα');
GO
INSERT INTO testTbl2 VALUES ('', 30, DEFAULT)

SET IDENTITY_INSERT testTbl2 on
GO
INSERT INTO testTbl2(id, userName,age,nation) VALUES (11,'񵿱', 29, '״')

INSERT INTO testTbl2 VALUES (12,'Ƶ庹', 31, '״')

SET IDENTITY_INSERT testTbl2 OFF
INSERT INTO testTbl2 VALUES ('Ƶ庹', 31, '״')
SELECT * FROM testTbl2

USE tempDB
CREATE TABLE testTbl3 (id int, Fname nvarchar(50), Lname nvarchar(50), tel nvarchar(25))
GO
INSERT INTO testTbl3 
  SELECT ContactID, FirstName, LastName, Phone
    FROM AdventureWorks.Person.Contact

UPDATE testTbl3
	SET tel = ''
	WHERE Fname = 'Kim'

USE sqlDB
UPDATE buyTbl SET price = price * 1.5 
SELECT * FROM buyTbl

USE tempDB
DELETE testTbl3 WHERE Fname = 'Kim'


/* -------------------------------
       <ǽ5> p224 ~ p225
---------------------------------*/

USE tempDB
SELECT * INTO bigTbl1 FROM AdventureWorks.Sales.SalesOrderDetail
SELECT * INTO bigTbl2 FROM AdventureWorks.Sales.SalesOrderDetail
SELECT * INTO bigTbl3 FROM AdventureWorks.Sales.SalesOrderDetail
GO

DELETE FROM bigTbl1

DROP TABLE bigTbl2

TRUNCATE TABLE bigTbl3

EXEC sp_tables  @table_type = "'TABLE'" ;


-------------------------------
-- P230
-------------------------------

EXEC sp_addtype 'typeName', 'nchar(10)', 'NULL', 'dbo'


/* -------------------------------
       <ǽ6> p231 ~ p232
---------------------------------*/

USE master
RESTORE DATABASE sqlDB FROM DISK = 'C:\sqlDB.bak' WITH REPLACE

DECLARE  @myVar1  INT
DECLARE  @myVar2  SMALLINT,  @myVar3 DECIMAL(5,2)
DECLARE  @myVar4  NCHAR(20)
SET @myVar1 = 5 
SET @myVar2 = 3
SET @myVar3 = 4.25
SET @myVar4 = '౸̸==> '
SELECT @myVar1
SELECT @myVar2 + @myVar3
USE sqlDB
SELECT @myVar4 , Name FROM userTbl WHERE height > 182

USE sqlDB
DECLARE  @myVar1  INT
SET @myVar1 = 3
SELECT TOP(@myVar1) Name, height FROM userTbl ORDER BY height


-------------------------------
-- P233 ~ P237
-------------------------------

USE sqlDB
SELECT AVG(amount) AS [ձŰ] FROM buyTbl

SELECT AVG( CAST(amount AS FLOAT) ) AS [ձŰ]  FROM buyTbl
  -- Ǵ
SELECT AVG( CONVERT(FLOAT, amount) ) AS [ձŰ]  FROM buyTbl

SELECT price, amount, price/amount AS [ܰ/] FROM buyTbl

SELECT price, amount, CAST(CAST(price AS FLOAT)/amount AS DECIMAL(10,2)) 
	AS [ܰ/] FROM buyTbl

DECLARE @myVar1 char(3)
SET @myVar1 = '100'
SELECT @myVar1 + '200' -- ڿ͹ڸ()
SELECT @myVar1 + 200   -- ڿ(:  Ͻȯ)
SELECT @myVar1 + 200.0 -- ڿͽǼ(: Ǽ Ͻȯ)

DECLARE @myVar1 char(3)
SET @myVar1 = '100'
SELECT @myVar1 + '200' -- ڿ͹ڸ()
SELECT CAST(@myVar1 AS INT) + 200   -- ڿ(:Ͻȯ)
SELECT CAST(@myVar1 AS DECIMAL(5,1)) + 200.0 -- ڿͽǼ(:Ͻȯ)

DECLARE @myVar2 DECIMAL(10,5)
SET @myVar2 = 10.123450
SELECT CAST(@myVar2 AS NCHAR(5))

DECLARE @myVar3 DECIMAL(10,5)
SET @myVar3 = 10.12345
SELECT CAST(@myVar3 AS INT)

DECLARE @myVar4 DECIMAL(10,5)
SET @myVar4 = 10.12345
SELECT CAST(@myVar4 AS DECIMAL(10,2))

-------------------------------
-- P237 ~ P240 (Į Լ)
-------------------------------

--- Լ
select @@LANGID 
SELECT @@SPID AS 'ID', SYSTEM_USER AS [αλ], USER AS [] 

-- ¥  ð Լ 
SELECT GETDATE()
SELECT DATEADD(day, 100, '2006/10/10') 
SELECT DATEDIFF(week, GETDATE(), '2022/10/19')
SELECT DATENAME(weekday, '2022/10/19')
SELECT MONTH('2022/10/19')

-- ġ  Լ
SELECT ABS(-100)
SELECT ROUND(1234.5678, 2), ROUND(1234.5678, -2)
SELECT RAND()
SELECT POWER(3,2)

-- Ÿ  Լ 
USE sqlDB
SELECT COL_LENGTH('userTbl','name')
SELECT DB_ID(N'AdventureWorks'); SELECT DB_NAME(6);
SELECT OBJECT_ID(N'sqlDB.dbo.userTbl'); 
SELECT OBJECT_NAME(2089058478); 

-- ڿ Լ 
SELECT ASCII('A'), CHAR(65)
SELECT UNICODE(''), NCHAR(44032)
SELECT CHARINDEX('Server' , 'SQL Server 2005')
SELECT LEFT('SQL Server 2005', 3), RIGHT('SQL Server 2005', 4)
SELECT SUBSTRING(N'ѹαȭ', 3, 2)
SELECT LEN('SQL Server 2005')
SELECT LOWER('abcdEFGH'), UPPER('abcdEFGH')
SELECT LTRIM('  յڵΰ  '), RTRIM('  յڵΰ  ')
SELECT REPLACE ('SQL Server 2005', 'Server' , '')
SELECT REPLICATE ('SQL', 5)
SELECT REVERSE ('SQL Server 2005')
SELECT STUFF ('SQL  2005', 5, 2, 'Server')SELECT SPACE(5) 


/* -------------------------------
       <ǽ7> p240 ~ p242
---------------------------------*/

USE tempDB
CREATE TABLE maxTbl 
 ( col1 VARCHAR(MAX),
   col2 NVARCHAR(max))

INSERT INTO maxTbl VALUES( REPLICATE('A',1000000),  REPLICATE('',1000000))

SELECT LEN(col1) AS [VARCHAR(MAX)], LEN(col2)AS [NVARCHAR(MAX)] FROM maxTbl

DELETE FROM maxTbl
INSERT INTO maxTbl VALUES( 
   REPLICATE( CAST('A' AS VARCHAR(MAX)) ,1000000 ) ,  
   REPLICATE( CONVERT(VARCHAR(MAX) , '' ) ,1000000) )   
SELECT LEN(col1) AS [VARCHAR(MAX)], LEN(col2)AS [NVARCHAR(MAX)] FROM maxTbl

UPDATE maxTbl SET col1 = REPLACE( (SELECT col1 FROM maxTbl),'A','B'),
                        col2 = REPLACE( (SELECT col2 FROM maxTbl),'','')

SELECT REVERSE((SELECT col1 FROM maxTbl))
SELECT SUBSTRING((SELECT col2 FROM maxTbl),999991, 10)

UPDATE maxTbl SET 
col1 = STUFF( (SELECT col1 FROM maxTbl),999991, 10, REPLICATE('C',10)),
  col2 = STUFF( (SELECT col2 FROM maxTbl),999991, 10, REPLICATE('',10))

UPDATE maxTbl SET col1.WRITE('DDDDD',999996, 5), col2.WRITE('',999996, 5)

SELECT REVERSE((SELECT col1 FROM maxTbl))
SELECT REVERSE((SELECT col2 FROM maxTbl))


/* -------------------------------
       <ǽ8> p244 ~ p248
---------------------------------*/

USE sqlDB
SELECT ROW_NUMBER( ) OVER(ORDER BY height DESC)[Űū ], 
  name, addr, height
FROM userTbl
ORDER BY height DESC

USE sqlDB
SELECT ROW_NUMBER( ) OVER(ORDER BY height DESC, name ASC)[Űū],
  name, addr, height
FROM userTbl
ORDER BY height DESC

USE sqlDB
SELECT addr,
  ROW_NUMBER( ) OVER(PARTITION BY addr
     ORDER BY height DESC, name ASC)[Űū],
name, height
FROM userTbl
ORDER BY addr, height DESC

USE sqlDB
SELECT DENSE_RANK( ) OVER(ORDER BY height DESC)[Űū],
  name, addr, height
FROM userTbl
ORDER BY height DESC

USE sqlDB
SELECT RANK( ) OVER(ORDER BY height DESC)[Űū],
  name, addr, height
FROM userTbl
ORDER BY height DESC

USE sqlDB
SELECT NTILE(2) OVER(ORDER BY height DESC) [ݹȣ],
  name, addr, height
FROM userTbl
ORDER BY height DESC

USE sqlDB
SELECT NTILE(4) OVER(ORDER BY height DESC) [ݹȣ],
  name, addr, height
FROM userTbl
ORDER BY height DESC


-------------------------------
-- P250 ~ P255 
-------------------------------

USE sqlDB
SELECT * 
FROM buyTbl
  INNER JOIN userTbl
     ON buyTbl.userid = userTbl.userid
WHERE buyTbl.userid = 'LCS'

SELECT userid, name, prodName, addr, mobile1 + mobile2 AS [ó]
FROM buyTbl
  INNER JOIN userTbl
     ON buyTbl.userid = userTbl.userid

SELECT buyTbl.userid, name, prodName, addr, mobile1 + mobile2 
FROM buyTbl
  INNER JOIN userTbl
     ON buyTbl.userid = userTbl.userid

SELECT buyTbl.userid, name, prodName, addr, mobile1 + mobile2  AS [ó]
FROM buyTbl, userTbl
WHERE buyTbl.userid = userTbl.userid

SELECT buyTbl.userid, userTbl.name, buyTbl.prodName, 
  userTbl.addr, userTbl.mobile1 + userTbl.mobile2  AS [ó]
FROM buyTbl
  INNER JOIN userTbl
     ON buyTbl.userid = userTbl.userid

SELECT B.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM buyTbl B
  INNER JOIN userTbl U
     ON B.userid = U.userid

SELECT B.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM buyTbl B
  INNER JOIN userTbl U
     ON B.userid = U.userid
WHERE B.userid = 'LCS'

SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM userTbl U
  INNER JOIN buyTbl B
     ON U.userid = B.userid 
WHERE B.userid = 'LCS'

SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM userTbl U
  INNER JOIN buyTbl B
     ON U.userid = B.userid 
ORDER BY U.userid

SELECT DISTINCT U.userid, U.name,  U.addr
FROM userTbl U
  INNER JOIN buyTbl B
     ON U.userid = B.userid 
ORDER BY U.userid

SELECT U.userid, U.name,  U.addr
FROM userTbl U
WHERE EXISTS (
   SELECT * 
   FROM buyTbl B
   WHERE U.userid = B.userid )


/* -------------------------------
       <ǽ9> p256 ~ p258
---------------------------------*/

USE sqlDB
CREATE TABLE stdTbl 
( stdName    nvarchar(10) NOT NULL PRIMARY KEY,
  addr	  nchar(4) NOT NULL
)
GO
CREATE TABLE clubTbl 
( clubName    nvarchar(10) NOT NULL PRIMARY KEY,
  roomNo	      nchar(4) NOT NULL
)
GO
CREATE TABLE stdclubTbl
(  num int IDENTITY NOT NULL PRIMARY KEY, 
   stdName    nvarchar(10) NOT NULL
		FOREIGN KEY REFERENCES stdTbl(stdName),
   clubName    nvarchar(10) NOT NULL
		FOREIGN KEY REFERENCES clubTbl(clubName),
)
GO

INSERT INTO stdTbl VALUES ('','')
INSERT INTO stdTbl VALUES ('ֿ','')
INSERT INTO stdTbl VALUES ('','')
INSERT INTO stdTbl VALUES ('õ','õ')
INSERT INTO stdTbl VALUES ('ȯ','')
GO
INSERT INTO clubTbl VALUES ('','101ȣ')
INSERT INTO clubTbl VALUES ('ٵ','102ȣ')
INSERT INTO clubTbl VALUES ('౸','103ȣ')
INSERT INTO clubTbl VALUES ('','104ȣ')
GO
INSERT INTO stdclubTbl VALUES ('','ٵ')
INSERT INTO stdclubTbl VALUES ('','౸')
INSERT INTO stdclubTbl VALUES ('','౸')
INSERT INTO stdclubTbl VALUES ('õ','౸')
INSERT INTO stdclubTbl VALUES ('õ','')
INSERT INTO stdclubTbl VALUES ('ȯ','')
GO

SELECT S.stdName, S.addr, C.clubName, C.roomNo
FROM stdTbl S 
  INNER JOIN stdclubTbl SC
       ON S.stdName = SC.stdName
  INNER JOIN clubTbl C
		ON SC.clubName = C.clubName
ORDER BY S.stdName

SELECT C.clubName, C.roomNo, S.stdName, S.addr
FROM  stdTbl S
  INNER JOIN stdclubTbl SC
       ON SC.stdName = S.stdName
  INNER JOIN clubTbl C
		ON SC.clubName = C.clubName
ORDER BY C.clubName


-------------------------------
-- P260 ~ P261 
-------------------------------

USE sqlDB
SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM userTbl U
  LEFT OUTER JOIN buyTbl B
     ON U.userid = B.userid 
ORDER BY U.userid

/* 带 80 ȯؾ .
SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  
FROM userTbl U, buyTbl B
WHERE U.userid *= B.userid 
ORDER BY U.userid
*/

SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM buyTbl B 
  RIGHT OUTER JOIN userTbl U
     ON U.userid = B.userid 
ORDER BY U.userid

SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM userTbl U
  LEFT OUTER JOIN buyTbl B
     ON U.userid = B.userid 
WHERE B.prodName IS NULL
ORDER BY U.userid

SELECT U.userid, U.name, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM userTbl U
WHERE NOT EXISTS (
   SELECT * 
   FROM buyTbl B
   WHERE U.userid = B.userid )
ORDER BY U.userid


/* -------------------------------
       <ǽ10> p262 ~ p263
---------------------------------*/

USE sqlDB
SELECT S.stdName, S.addr, C.clubName, C.roomNo
FROM stdTbl S 
  LEFT OUTER JOIN stdclubTbl SC
       ON S.stdName = SC.stdName
  LEFT OUTER JOIN clubTbl C
		ON SC.clubName = C.clubName
ORDER BY S.stdName

SELECT C.clubName, C.roomNo, S.stdName, S.addr
FROM  stdTbl S
  LEFT OUTER JOIN stdclubTbl SC
       ON SC.stdName = S.stdName
  RIGHT OUTER JOIN clubTbl C
		ON SC.clubName = C.clubName
ORDER BY C.clubName

SELECT S.stdName, S.addr, C.clubName, C.roomNo
FROM stdTbl S 
  FULL JOIN stdclubTbl SC
       ON S.stdName = SC.stdName
  FULL JOIN clubTbl C
		ON SC.clubName = C.clubName
ORDER BY S.stdName


-------------------------------
-- P264 ~ P268 
-------------------------------

USE sqlDB
SELECT * 
FROM buyTbl 
  CROSS JOIN userTbl 

SELECT * 
  FROM buyTbl , userTbl

USE AdventureWorks
SELECT CAST(COUNT(A) AS CHAR(10)) + COUNT_BIG(*) AS [Ͱ]
FROM Sales.SalesOrderDetail A
  CROSS JOIN Sales.SalesOrderHeader B

USE sqlDB
SELECT A.emp AS [] , B.emp AS [ӻ], B.department AS [ӻμ]
FROM empTbl A
  INNER JOIN empTbl B
  ON A.manager = B.emp
WHERE A.emp = '븮'

USE AdventureWorks
SELECT E.EmployeeID AS [ȣ], 
   E.ManagerID AS [ڹȣ],
   C.FirstName + ' ' + C.MiddleName + ' ' + C.LastName AS [̸],
   C.EmailAddress AS [ڸ]
FROM HumanResources.Employee E  -- ̺
  INNER JOIN HumanResources.Employee M  --̺
    ON E.ManagerID = M.EmployeeID  
/* Where  ִ ̺ 2 (6)  
  (ᱹ, HumanResources.Employee ̺ ȣ 6   */
  INNER JOIN Person.Contact C   
    ON M.ContactID = C.ContactID 
/*  ο  (ȣ 6) ContactID Person.Contact̺ ContactID   
   --> ᱹ [׸ 6-45]  */
WHERE E.EmployeeID = 2

USE sqlDB
SELECT stdName, addr FROM stdTbl
UNION ALL
SELECT clubName, roomNo FROM clubTbl


-------------------------------
-- P269 ~ P272 
-------------------------------

DECLARE @var1 INT  -- @var1  
SET @var1=100  --   
IF @var1 = 100   --  @var1  100̶,
	BEGIN
		PRINT '@var1 100 ̴'
	END
ELSE
	BEGIN
		PRINT '@var1 100̾ƴϴ.'
	END

USE AdventureWorks
DECLARE @hireDate SMALLDATETIME -- Ի
DECLARE @curDate SMALLDATETIME -- 
DECLARE @years DECIMAL(5,2) -- ٹѳ
DECLARE @days INT -- ٹϼ
SELECT @hireDate = HireDate  -- HireDateǰ@hiredate
  FROM HumanResources.Employee
  WHERE EmployeeID = 111
SET @curDate = GETDATE() -- 糯¥
SET @years = DATEDIFF(year, @hireDate, @curDate)  --¥ , 
SET @days =  DATEDIFF(day, @hireDate, @curDate) --¥ , ϴ
IF ( @years >= 5)
  BEGIN
PRINT N'Ի' + CAST(@days AS NCHAR(5)) + N'̳ϴ.'
    PRINT N'մϴ.'
  END
ELSE
  BEGIN
PRINT N'Ի' + CAST(@days AS NCHAR(5)) + N'ϹۿȵǾ׿.'
    PRINT N'ϼ.'
 END

DECLARE @point INT, @credit NCHAR(1)
SET @point = 77
IF @point >= 90
    SET @credit = 'A'
ELSE
    IF @point >= 80
        SET @credit = 'B'
    ELSE
      IF @point >= 70
          SET @credit = 'C'
      ELSE
        IF @point >= 60
            SET @credit = 'D'
        ELSE
            SET @credit = 'F'
PRINT '==> ' + CAST(@point AS NCHAR(3))
PRINT '==> ' + @credit

DECLARE @point INT, @credit NCHAR(1)
SET @point = 100
SET @credit =
  CASE  
     WHEN (@point >= 90)  THEN 'A' 
     WHEN (@point >= 80)  THEN 'B'
     WHEN (@point >= 70)  THEN 'C'
     WHEN (@point >= 60)  THEN 'D'
     ELSE  'F'
  END
PRINT '==> ' + CAST(@point AS NCHAR(3))
PRINT '==> ' + @credit


/* -------------------------------
       <ǽ11> p272 ~ p275
---------------------------------*/

USE master
RESTORE DATABASE sqlDB FROM DISK = 'C:\sqlDB.bak' WITH REPLACE 

USE sqlDB
SELECT userid,  sum(price*amount) AS [ѱž]
   FROM buyTbl
GROUP BY userid
ORDER BY sum(price*amount) DESC

SELECT B.userid, U.name, sum(price*amount) AS [ѱž]
   FROM buyTbl B
     INNER JOIN userTbl U
       ON B.userid = U.userid
GROUP BY B.userid, U.name
ORDER BY sum(price*amount) DESC

SELECT B.userid, U.name, sum(price*amount) AS [ѱž]
   FROM buyTbl B
     RIGHT OUTER JOIN userTbl U
       ON B.userid = U.userid
GROUP BY B.userid, U.name
ORDER BY sum(price*amount) DESC

SELECT U.userid, U.name, sum(price*amount) AS [ѱž]
   FROM buyTbl B
     RIGHT OUTER JOIN userTbl U
       ON B.userid = U.userid
GROUP BY U.userid, U.name
ORDER BY sum(price*amount) DESC

SELECT U.userid, U.name, sum(price*amount) AS [ѱž],
    CASE  
        WHEN (sum(price*amount)  >= 2000) THEN N'ֿ'
        WHEN (sum(price*amount)  >= 1000) THEN N''
        WHEN (sum(price*amount) >= 1 ) THEN N'Ϲݰ'
        ELSE N'ɰ'
     END AS []
FROM buyTbl B
   RIGHT OUTER JOIN userTbl U
      ON B.userid = U.userid
GROUP BY U.userid, U.name 
ORDER BY sum(price*amount) DESC


-------------------------------
-- P276 ~ P279 
-------------------------------

DECLARE @i INT  -- 1100Һ
DECLARE @hap BIGINT -- ѰҺ
SET @i = 1
SET @hap = 0
WHILE (@i <= 100)
BEGIN
  SET @hap = @hap + @i
  SET @i = @i + 1
END
PRINT @hap

DECLARE @i INT  -- 1100Һ
DECLARE @hap BIGINT -- ѰҺ
SET @i = 1
SET @hap = 0
WHILE (@i <= 100)
BEGIN
  IF (@i % 7 = 0) 
     BEGIN
	    PRINT '7ǹ: ' + CAST (@i AS NCHAR(3))
        SET @i = @i + 1
        CONTINUE
     END
   SET @hap = @hap + @i
   IF (@hap > 1000) BREAK
   SET @i = @i + 1
END
PRINT 'հ=' + CAST(@hap AS NCHAR(10))

DECLARE @i INT  -- 1100Һ
DECLARE @hap BIGINT -- ѰҺ
SET @i = 1
SET @hap = 0
WHILE (@i <= 100)
BEGIN
  IF (@i % 7 = 0) 
     BEGIN
	    PRINT '7ǹ: ' + CAST (@i AS NCHAR(3))
        SET @i = @i + 1
        CONTINUE
     END
   SET @hap = @hap + @i
   IF (@hap > 1000) GOTO endprint
   SET @i = @i + 1
END
endprint:
PRINT 'հ=' + CAST(@hap AS NCHAR(10))

USE sqlDB
BEGIN TRY
  INSERT INTO userTbl VALUES('AJH', '', 1988, '', NULL, NULL, 170)
  PRINT N'ԷµǾ.'
END TRY
BEGIN CATCH
   PRINT N'߻ߴ.'
END CATCH

BEGIN TRY
  INSERT INTO userTbl VALUES('AJH', '', 1988, '', NULL, NULL, 170)
  PRINT N'ԷµǾ.'
END TRY
BEGIN CATCH
   PRINT N'***߻ߴ***'
   PRINT N'ȣ: ' 
   PRINT ERROR_NUMBER()
   PRINT N'޽: '
   PRINT ERROR_MESSAGE() 
   PRINT N'ڵ: '
   PRINT ERROR_STATE() 
   PRINT N'ɰ: '
   PRINT ERROR_SEVERITY() 
   PRINT N'߻ȣ: '
   PRINT ERROR_LINE() 
   PRINT N'߻ν/Ʈ: '
   PRINT ERROR_PROCEDURE() 
END CATCH

